// gE`gM+tB^vO
// RC0 == 0F搳gE`g[h
// RC0 == 1F搳gE`g[h

#include	<xc.h>
#include	"./PIC16F1705_Files/pic16f1705_s.h"
#include    "./PIC16F1705_Files/sin_data.h"
#include    "./PIC16F1705_Files/f_mul_data.h"

#pragma config FOSC = INTOSC   		// IV[^ ICRA5NbN͗pł͂ȂC I/Opɐݒ
#pragma config WDTE = OFF       	// EHb`hbO^C} It
#pragma config PWRTE = OFF     		// pAbv^C} It
#pragma config MCLRE = ON      		// 4ԃsMCLRpɐݒ
#pragma config CP = OFF         	// R[hی It
#pragma config BOREN = OFF     		// dZbg It
#pragma config CLKOUTEN = OFF       // NbNMo̓siRA4j It
#pragma config IESO = OFF       	// dグ̓IV[^  OIV[^ؑ It
#pragma config FCMEN = OFF      	// tFCZ[tNbNj^ It
#pragma config WRT = OFF        	// tbVݕی It
#pragma config ZCDDIS = 1           // [NXo~
#pragma config PPS1WAY = 1          // PPS (Peripheral Pin Select) LOCK|Di{vOłI/Osւ̎ӃW[̊蓖ĂvOsɕς邱Ƃ͂ȂDj
#pragma config PLLEN = ON       	// PLL I
#pragma config STVREN = OFF     	// X^bNI[o[^A_[t[Zbg It
#pragma config BORV = HI        	// dZbg̐ݒd2.7[V]ɐݒ (LOW=1.9 [V])
#pragma config LVP = ON	        	// diႦ3.3 [V]jł̃vO~O I

unsigned int ad_out;                // A/Dϊl
unsigned int intrpt_period;         // ^C}P荞ݎgݒl

// g`pf[^
#define     sin_div         800     // 1Ԃ̃f[^
#define     sin_div_half    400     // 
unsigned int sin_step = 0;			// gf[^̔ԒnJE^

//(惂[h̕ϐC萔)
unsigned int freq_mul_num;          // gf[^ǂݏoƂ̃f[^Ԉi惂[hj
unsigned int th_now;                // f_com 臒ľݒl 
unsigned int th_step = 4480;        // f_com 臒l̃Xebv [0, 65472]͈̔͂ 14 
unsigned int th_hys = 2048;         // f_com臒l̃qXeVX




static void __interrupt()           // Timer1 ɂ銄荞ݏ[`
timer1_isr(void)
{
    RC5 = 1;                        // |[gCRC5(5ԃs)1o͂D荞ݏԂ̃j^Op
    
    clear_interrupt_flag_of_timer1();
                                    // 荞݃tONAD^C}1ɂ X ̃JEg_El 0 ɓB_łPɃZbgCĊ荞݂ȂD
    
    if(RC0 == 1) // 惂[h
    {
        set_timer1_count_down_ini_num(220);
    						// ^C}1̃JEg_El̐ݒD
							// 220JEg_EsC0ōĊ荞݂𔭐
                            // 32MHz/(220 + 156) = 85 [kHz]
                            // (85 [kHz]/sin_div)*freq_multiplier = (85kHz/800)*(min 1 -- max 100) @Min 106 [Hz] -- Max 10.6 [kHz]
        set_DA_Output(sin_data[sin_step]);

        sin_step += freq_multiplier[freq_mul_num]; // freq_multiplier[]̒lf[^XLbvݒDfreq_multipler[]̒lf_mul_data.hŒ`ĂDfreq_mul_num ̒lmain()֐Őݒ肵ĂD)
        
    }else   // 惂[h
    {   	
        set_timer1_count_down_ini_num(intrpt_period);
                                    // ^C}1̃JEg_El̐ݒD
                                    // .._num(X) X JEg_EsC0ōĊ荞݂𔭐C荞ݎg f_intrpt = 16MHz/(X+160) ƂȂDX = 3040 ̂ƂCf_intrpt = 5 [kHz].
                                    // 荞ݎAutomatic Context Saving(WX^l̃X^bNւ̑ޔƕA)Ɍv104Xebv]ɗvĂD
                                    // Xmin͊荞ݏvȌԂɈˑD
                                    // ̃vOł Xmin = 224DXĂ荞ݎg͏オȂD܂Cintrpt_period̍XVłȂȂ\ND
        
        set_DA_Output(sin_data[sin_step++]);
                                    // D/AϊW[ɐgf[^Zbgigj
                
        if(sin_step < sin_div_half) // `g
        {
            RA5 = 1;
        }else
        {
            RA5 = 0;
        }
    }
    
    if(sin_step >= sin_div)         // sin_step = sin_divɂsin_step = 0 ɃZbg
    {
        sin_step = 0;
    }
    
    RC5 = 0;                        // |[gCRC5(5ԃs)0o͂D荞ݏԂ̃j^Op
}

// maximumlvZ֐
unsigned int max_func(unsigned int a, unsigned int b)
{
    if(a > b)
    {
        return(a);
    }else{
        return(b);
    }
}


void main()
{
    unsigned int ad_out_mod;        // A/Dϊʂ̊Zl
    
	TRISA = 0x10;                   // RA4i3ԃsj̓|[gɐݒ
	TRISC = 0x31;                   // RC0,4,5i5,6,10ԃsj̓|[gɐݒ
    ANSELA = 0x10;                  // RA4i3ԃsjAiO͂ɐݒD̑fBW^͂ɐݒ
    ANSELC = 0x30;                  // RC4, 5i5, 6ԃsjAiO͂ɐݒD̑fBW^͂ɐݒ

    //IV[^̐ݒ
    if(RC0 == 1)
    {
            set_osc(Int_OSC_Freq_8MHz, SysClockSource_detmd_by_Config);
			// IV[^8MHzPLLEN = ON f_OSC = 32 [MHz]ɐݒ肷D (foCXRtBM[VɂPLLEN = ONƂĂƁC8MHẑƂPLLɂ4{Dj       
    }else
    {
            set_osc(Int_OSC_Freq_16MHz, SysClockSource_int_OSC_block);
			// IV[^16MHz f_OSC = 16MHzɐݒ肷D              
    }

   	//@^C}[1̐ݒ
   	set_timer1(TMR1_clock_source_FOSC, T1Clock_PreScale_1_1, TMR1_ON);
			// ^C}P̃NbN\[XCݒ肵āC^C}1IƂD
   	set_interrupt_by_timer1();
    		// ^C}1ɂ銄荞݂ƂD    

    // A/DRo[^̐ݒ
    set_AD_Converter(select_AN3, AD_ON, left_justified, clock_1_32, neg_ref_VSS, pos_ref_VDD);   
            
    // FVR̐ݒ
    set_FVR(FVR_ON, da_ref_4_096, ad_ref_4_096);    
    
    // D/ARo[^̐ݒ
    set_DA_Converter(DAC_on, DAC_not_to_DAC1OUT1, DAC_not_to_DAC1OUT2, DAC_Positive_Source_to_VDD, DAC_Negative_Source_to_VSS);

    // IyAv̐ݒ
    set_Op_Amp1(Op_Amp1_on, Op_Amp1_High_GBWP, Op_Amp1_Unity_Gain, Op_Amp1_Pos_Input_to_DAC_output);  
    set_Op_Amp2(Op_Amp2_on, Op_Amp2_High_GBWP, Op_Amp2_Neg_Input_to_OPA2IN, Op_Amp2_Pos_Input_to_OPA2IN_P);  

    
    // ɂf[^Ԉ(freq_mul_num)Ǝgwߒl臒lݒl(th_now)̏lD
    // ad_out [0, 0b1111 1111 1100 0000] = [0, 65472]͈̔͂ɂDth_step ̊Ԋu臒l݂ĂDad_out̏lɉāCfreq_mul_num  th_now 肷D
        start_ad_conversion();
        ad_out = read_result_of_ad_conversion();

        freq_mul_num = ad_out/th_step;
        if(freq_mul_num == 14){freq_mul_num = 13;}
        th_now = (freq_mul_num + 1)*th_step;

    // [v
	for(;;)
    {
        //A/Dϊ
        start_ad_conversion();
        ad_out = read_result_of_ad_conversion();
        if(RC0 == 1)            //惂[h
        {
            // f_comlɉāCgf[^̊Ԉ
            if(th_now == th_step)                           // 臒lŏl̂Ƃ̗O   
            {
                if(ad_out > (th_now + th_hys))
                {
                    th_now += th_step; 
                    freq_mul_num++;
                }
            }else if(th_now == (14*th_step))                // 臒lől̂Ƃ̗O
            {
                if(ad_out < (th_now - th_step - th_hys))
                {
                    th_now -= th_step;
                    freq_mul_num--;
                }
            }else if(ad_out > (th_now + th_hys))            // 臒l + qXeVX ňigֈڍs
            {
                th_now += th_step; 
                freq_mul_num++;
            }else if(ad_out < (th_now - th_step - th_hys))  // 臒l -i臒l̃Xebvj - (qXeVX) ňiႢgւƈڍs
            {
                th_now -= th_step;
                freq_mul_num--;
            }
        }else
        {                  // 惂[h
            if(ad_out > 13107)                              // {[̊xg4{ɂCg1/4ɂĂD]āCgƍgŃ{[̊x8:1ɂĂD
            {                                               // gƍg̋E 16 [MHz]/(0xFFFF - 49151 - 13108/4 + 160)/i800̃f[^j = 1.5 [Hz]
                ad_out_mod = (ad_out/4) + 49151;
            }else{
                ad_out_mod = ad_out*4;
            }
        
            intrpt_period = max_func(0xFFFF - ad_out_mod, 224); // 荞ݎ̐ݒDintpr_period̉l224ɐݒ
            
        }   
    }
}