// IV[^W[̗p`

// OSCCON(Oscillator Control Register)

	// SPLLEN(PLL̗p̗Lݒ)
//	#define SPLLEN_4xPLL_en   0b1		// 4~PLL Enabled
										//  IRCF8MHzƑgݍ킹FOSC = 32MHzɐݒłD
//	#define SPLLEN_4xPLL_dis  0b0		// 4~PLL Disabled
	   // RtBM[Vݒ PLLEN_ONł΁CSPLLEN̒lɂ炸4~PLL͏ONłD


	// IRCF(IV[^̔Mgݒ)
	#define 	Int_OSC_Freq_16MHz      0b1111		
	#define 	Int_OSC_Freq_8MHz       0b1110
	#define 	Int_OSC_Freq_4MHz       0b1101
	#define 	Int_OSC_Freq_2MHz       0b1100
	#define 	Int_OSC_Freq_1MHz       0b1011
	#define 	Int_OSC_Freq_500kHz 	0b1010
	
	// SCS(VXeNbN(FOSC)ɂǂ̃NbN𗘗p邩ݒ肷D)
	#define SysClockSource_int_OSC_block 	0b11    // IV[^ubN̏o͂pD
                                                    // ̂ƂCIRCFWX^Őݒ肵lf_OSCƂȂD
                                                    // PLLgpȂݒD
	#define SysClockSource_32_768kHz        0b01    // T1OSI(2ԃs), T1OSOs(3ԃsj32.768kHz
                                                    // UڑāC̏o͂pD
	#define SysClockSource_detmd_by_Config 	0b00	//RtBM[VݒFOSC = ENPLLEN = ON ̐ݒɏ]D
                                                    // IRCFݒ肪Int_OSC_Freq_16MHzł f_OSC = 16 MHzƂȂD
                                                    //  Int_OSC_Freq_8MHz ł΁CPLLɂ f_OSC = 32 MHzƂȂD 

//֐̐錾
void set_osc(unsigned char x,unsigned char y);



// ^C}PW[̗p`

// T1CON(Timer1 Control Register)

	// TMR1CS(^C}1̃NbN\[Xݒ肷)
	#define TMR1_clock_source_LFINTOSC      0b11	// Low Frequency Internal Oscillator̃NbN𗘗pD
	#define TMR1_clock_source_T1Ck_SOSC 	0b10	// ONbN(T1CKIjor SOSC/SOSCI͂𗘗pD
	#define TMR1_clock_source_FOSC          0b01	// VXeNbN(FOSC)𗘗pD
	#define TMR1_clock_source_FOSC_1_4  	0b00	// VXeNbN(FOSC/4)𗘗pD

	// T1CKPS(^C}1ɓNbN̕ݒ肷D) 
	#define T1Clock_PreScale_1_8    0b11	// 1/8ɂD
	#define T1Clock_PreScale_1_4    0b10	// 1/4ɂD
	#define T1Clock_PreScale_1_2    0b01	// 1/2ɂD
	#define T1Clock_PreScale_1_1    0b00	// 1/1ɂD


	// TMR1ON(^C}P̃I^ItݒD)
	#define TMR1_ON    0b1
	#define TMR1_OFF   0b0
	
 	//̗̑p̓ftHgݒŖ{̎gɖ֌WȂ̂ŁCȗDj

//֐̐錾
void set_timer1_count_down_ini_num(unsigned int a);
void clear_interrupt_flag_of_timer1(void);
void set_timer1(unsigned char a,unsigned char b, unsigned char c);
void set_interrupt_by_timer1(void);


// A/DϊW[̗p`

// ADCON0(A/D Control Register 0)

	// CHS(Analog Channel Select bits)
	#define select_AN0	0b00000		//AN0I
	#define select_AN1	0b00001		//AN1
	#define select_AN2	0b00010		//AN2
	#define select_AN3	0b00011		//AN3
	#define select_AN4	0b00100		//AN4
	#define select_AN5	0b00101		//AN5
	#define select_AN6	0b00110		//AN6
	#define select_AN7	0b00111		//AN7

	// ADON(A/D Conversion Enable bit)
	#define AD_ON		0b1		//A/DRo[^IƂ
	#define AD_OFF		0b0		//@@@@@@@ It


// ADCON1(A/D Control Register 1)

	// ADFM(A/D Result Format Select bit)
	#define right_justified	0b1		//ϊʂ16rbgWX^̉E悹Ŋi[D
	#define left_justified	0b0		//@@@@@@@              悹

	// ADCS(A/C Conversion Clock Select bits)
	#define clock_1_2	0b000		// A/DRo[^̃NbNFOSC/2ƂD
	#define clock_1_8	0b001		// @@@@@@@@@@@ @FOSC/8
	#define clock_1_32	0b010		//@@@@@@@@@@@@@FOSC/32
	#define clock_FRC	0b011		// RCIV[^̃NbNgD
	#define clock_1_4	0b100		//                        @FOSC/4
	#define clock_1_16	0b101		//                        @FOSC/16
	#define clock_1_64	0b110		//                        @FOSC/64
	#define clock_FRC1	0b111		// RCIV[^̃NbNgD

	// ADNREF(A/D Negative Voltage Reference Configuration bit)
	#define neg_ref_VSS     0b0		// A/DRo[^̊d́|VSSƂD
	#define neg_ref_exVREFM 0b1		//             @@@@@@@@ OVREF-sƂ

	// ADPREF(A/D Positive Voltage Reference Configuration bit)
	#define pos_ref_VDD     0b00		// A/DRo[^̊d+VDDƂD
	#define pos_ref_exVREFP 0b10		//                             OVREF+sƂ
	#define pos_ref_FVR     0b11		// dFVR(Fixed Voltage Reference)̓dgp


// FVRCON(Fixed Voltage Reference Control Register)

	// FVREN(FVR Enable bit)
	#define FVR_OFF		0b0		// FVR It
	#define FVR_ON		0b1		// FVR I

    // CDAFVR (Comparator, DA Converter FVR Buffer Gain Selection)
    #define da_ref_off      0b00		// FVRɂdItƂD
	#define da_ref_1_024	0b01		// FVRɂd1.024 [V]ɐݒ
	#define da_ref_2_048	0b10		//                    2.048 [V]
	#define da_ref_4_096	0b11		//                    4.096 [V]

	// ADFVR(FVR setting for AD Converter)
	#define ad_ref_OFF      0b00		// FVRɂdItƂD
	#define ad_ref_1_024	0b01		// FVRɂd1.024 [V]ɐݒ
	#define ad_ref_2_048	0b10		//                    2.048 [V]
	#define ad_ref_4_096	0b11		//                    4.096 [V]

//֐̐錾
void set_AD_Converter(unsigned char a, unsigned char b, unsigned char c, unsigned char d, unsigned char e, unsigned char f);
void set_FVR(unsigned char a, unsigned char b, unsigned char c);
void start_ad_conversion(void);
unsigned int read_result_of_ad_conversion(void);
void start_ad_conversion_ch_select(unsigned int a);



// ^C}QW[̗p`

// T2CON (Timer2 Control Register)

	// T2OUTPS (Timer2 Output Postscaler Select bits)
	#define set_Postscaler_1_1		0b0000 	// 1:1Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_2		0b0001 	// 1:2Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_3		0b0010 	// 1:3Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_4		0b0011 	// 1:4Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_5		0b0100 	// 1:5Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_6		0b0101 	// 1:6Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_7		0b0110 	// 1:7Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_8		0b0111 	// 1:8Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_9		0b1000 	// 1:9Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_10		0b1001 	// 1:10Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_11		0b1010 	// 1:11Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_12		0b1011 	// 1:12Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_13		0b1100 	// 1:13Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_14		0b1101 	// 1:14Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_15		0b1110 	// 1:15Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_16		0b1111 	// 1:16Ƀ^C}2o͂𕪎

	// TMR2ON (Timer2 On bit)
	#define timer2_on		0b1	// ^C}2IƂD
	#define timer2_off		0b0	// ^C}2ItƂD

	// T2CKPS (Timer2 Clock Prescale Select bits)
	#define set_Prescaler_1_1		0b00	// 1:1Ƀ^C}2͂𕪎
	#define set_Prescaler_1_4		0b01	// 1:4Ƀ^C}2͂𕪎
	#define set_Prescaler_1_16		0b10	// 1:16Ƀ^C}2͂𕪎
	#define set_Prescaler_1_64		0b11	// 1:64Ƀ^C}2͂𕪎

//֐̐錾
void set_timer2(unsigned int a, unsigned int b, unsigned int c, unsigned int d);
void set_interrupt_by_timer2(void);
void clear_interrupt_flag_of_timer2(void);




// D/AϊW[̗p`

// DAC1CON0(Voltage Reference Control Register 0)

    // DAC1EN (DAC1 Enable bit)
    #define DAC_on      0b1 // DAϊIƂD
    #define DAC_off     0b0 //           ItƂD

    // DAC1OE1 (DAC1 Voltage Output 1 Enable bit)
    #define DAC_to_DAC1OUT1     0b1 // D/ARo[^o͂DAC1OUT1sɐڑ
    #define DAC_not_to_DAC1OUT1 0b0 //                  @DAC1OUT1sɔڑ

    // DAC1OE2 (DAC1 Voltage Output 1 Enable bit)
    #define DAC_to_DAC1OUT2     0b1 // D/ARo[^o͂DAC1OUT2sɐڑ
    #define DAC_not_to_DAC1OUT2 0b0 //                  @DAC1OUT2sɔڑ

    // DAC1PSS (DAC1 Positive Source Select bit)
    #define DAC_Positive_Source_to_FVR      0b10 // D/ARo[^̐dFVRƂD
    #define DAC_Positive_Source_to_Vref_P   0b01 //                 @@@@ Vref+ƂD
    #define DAC_Positive_Source_to_VDD      0b00 //           @@@@@     VDDƂD

    // DAC1NSS (DAC1 Negative Source Select bit)
    #define DAC_Negative_Source_to_Vref_N   0b1 // D/ARo[^̕dVref-ƂD
    #define DAC_Negative_Source_to_VSS      0b0 //                      @@VSSƂD

//֐̐錾
void set_DA_Converter(unsigned char a, unsigned char b, unsigned char c, unsigned char d, unsigned char e);
void set_DA_Output(char a);


// IyAv̗p`

// OPA1CON (Op Amp1 Control Register)

    // OPA1EN (Op Amp1 Enable bit)
    #define Op_Amp1_on   0b1 // Op Amp1IƂD      
    #define Op_Amp1_off  0b0 // Op Amp1ItƂD      

    // OPA1SP (Op Amp1 Speed/Power Select bit)
    #define Op_Amp1_High_GBWP    0b1 // Op Amp1QC~oh[hɐݒ      
    #define Op_Amp1_not_H_GBWP   0b0 // f[^V[gɂ0͎gpȂƂD

    // OPA1UG (Op Amp Unitiy Gain Select bit)
    #define Op_Amp1_Unity_Gain           0b1 // Op Amp1{e[WtHɐݒ      
    #define Op_Amp1_Neg_Input_to_OPA1IN  0b0 // Op Amp1-͂OPA1IN-ɐڑ

    // OPA1PCH (Op Amp1 Non-Inverting Channenl Selecton bits)
    #define Op_Amp1_Pos_Input_to_FVR         0b11 // {͂FVRɐڑ      
    #define Op_Amp1_Pos_Input_to_DAC_output  0b10 //         D/ARo[^o͂ɐڑ
    #define Op_Amp1_Pos_Input_to_OPA1IN_P    0b00 //         OPA1IN+ɐڑ


// OPA2CON (Op Amp2 Control Register)

    // OPA2EN (Op Amp2 Enable bit)
    #define Op_Amp2_on   0b1 // Op Amp2IƂD      
    #define Op_Amp2_off  0b0 // Op Amp2ItƂD      

    // OPA2SP (Op Amp2 Speed/Power Select bit)
    #define Op_Amp2_High_GBWP    0b1 // Op Amp2QC~oh[hɐݒ      
    #define Op_Amp2_not_H_GBWP   0b0 // f[^V[gɂ0͎gpȂƂD

    // OPA2UG (Op Amp2 Unitiy Gain Select bit)
    #define Op_Amp2_Unity_Gain           0b1 // Op Amp2{e[WtHɐݒ      
    #define Op_Amp2_Neg_Input_to_OPA2IN  0b0 // Op Amp2-͂OPA2IN-ɐڑ

    // OPA2PCH (Op Amp2 Non-Inverting Channenl Selecton bits)
    #define Op_Amp2_Pos_Input_to_FVR         0b11 // {͂FVRɐڑ      
    #define Op_Amp2_Pos_Input_to_DAC_output  0b10 //         D/ARo[^o͂ɐڑ
    #define Op_Amp2_Pos_Input_to_OPA2IN_P    0b00 //         OPA2IN+ɐڑ

// ֐̐錾
void set_Op_Amp1(unsigned char a, unsigned char b, unsigned char c, unsigned char d);
void set_Op_Amp2(unsigned char a, unsigned char b, unsigned char c, unsigned char d);
