// D/AϊvO

#include	<xc.h>
#include	"./PIC16F1705_Files/pic16f1705_s.h"
#include    "./PIC16F1705_Files/sin_data.h"

#pragma config FOSC = INTOSC   		// IV[^ ICRA5NbN͗pł͂ȂC I/Opɐݒ
#pragma config WDTE = OFF       	// EHb`hbO^C} It
#pragma config PWRTE = OFF     		// pAbv^C} It
#pragma config MCLRE = ON      		// 4ԃsMCLRpɐݒ
#pragma config CP = OFF         	// R[hی It
#pragma config BOREN = OFF     		// dZbg It
#pragma config CLKOUTEN = OFF       // NbNMo̓siRA4j It
#pragma config IESO = OFF       	// dグ̓IV[^  OIV[^ؑ It
#pragma config FCMEN = OFF      	// tFCZ[tNbNj^ It
#pragma config WRT = OFF        	// tbVݕی It
#pragma config ZCDDIS = 1           // [NXo~
#pragma config PPS1WAY = 1          // PPS (Peripheral Pin Select) LOCK|Di{vOłI/Osւ̎ӃW[̊蓖ĂvOsɕς邱Ƃ͂ȂDj
#pragma config PLLEN = ON       	// PLL I
#pragma config STVREN = OFF     	// X^bNI[o[^A_[t[Zbg It
#pragma config BORV = HI        	// dZbg̐ݒd2.7[V]ɐݒ (LOW=1.9 [V])
#pragma config LVP = ON	        	// diႦ3.3 [V]jł̃vO~O I

unsigned int ad_out;                // A/Dϊl
unsigned int intrpt_period;         // ^C}P荞ݎgݒl

// g`pf[^
#define		sin_div         800     // 1Ԃ̃f[^
unsigned int sin_step = 0;			//gf[^̔ԒnJE^

static void __interrupt()           // Timer1 ɂ銄荞ݏ[`
timer1_isr(void)
{
    clear_interrupt_flag_of_timer1();
                                    // 荞݃tONAD^C}1ɂ X ̃JEg_El 0 ɓB_łPɃZbgCĊ荞݂ȂD
    RC5 = 1;                        // |[gCRC5(5ԃs)1o͂D荞ݏԂ̃j^Op
    
    set_timer1_count_down_ini_num(intrpt_period);
                                    // ^C}1̃JEg_El̐ݒD
                                    // .._num(X) X JEg_EsC0ōĊ荞݂𔭐C荞ݎg f_intrpt = 16MHz/(X+136) ƂȂDX = 3064 ̂ƂCf_intrpt = 5 [kHz].
                                    // 荞ݎAutomatic Context Saving(WX^l̃X^bNւ̑ޔƕA)Ɍv104Xebv]ɗvĂD
                                    // Xmin͊荞ݏvȌԂɈˑD
                                    // ̃vOł Xmin = 172DXĂ荞ݎg͏オȂD܂Cintrpt_period̍XVłȂȂ\ND
        
    set_DA_Output(sin_data[sin_step++]);
                                    // D/AϊW[ɐgf[^Zbg
        
    if(sin_step >= sin_div)         // sin_step = sin_divɂsin_step = 0 ɃZbg
    {
        sin_step = 0;
    }
        
    RC5 = 0;                    // |[gCRC5(5ԃs)0o͂D荞ݔ̃j^Op
}

// maximumlvZ֐
unsigned int max_func(unsigned int a, unsigned int b)
{
    if(a > b)
    {
        return(a);
    }else{
        return(b);
    }
}

void main()
{
	TRISA = 0x00;               // RAxo̓|[gɐݒ
	TRISC = 0x09;               // RC3i7ԃsj, RC0i10ԃsj̓|[gɐݒ
    ANSELA = 0x00;              // RAxfBW^͂ɐݒ
    ANSELC = 0x08;              // RC3i7ԃsjAiO͂ɐݒ, ̑fBW^͂ɐݒ

    //IV[^̐ݒ
    if(RC0 == 1)
    {
            set_osc(Int_OSC_Freq_8MHz, SysClockSource_detmd_by_Config);
			// IV[^8MHzPLLEN = ON f_OSC = 32 [MHz]ɐݒ肷D (foCXRtBM[VɂPLLEN = ONƂĂƁC8MHẑƂPLLɂ4{Dj       
    }else
    {
            set_osc(Int_OSC_Freq_16MHz, SysClockSource_int_OSC_block);
			// IV[^16MHz f_OSC = 16MHzɐݒ肷D                
    }

   	//@^C}[1̐ݒ
   	set_timer1(TMR1_clock_source_FOSC, T1Clock_PreScale_1_1, TMR1_ON);
			// ^C}P̃NbN\[XCݒ肵āC^C}1IƂD
   	set_interrupt_by_timer1();
    		// ^C}1ɂ銄荞݂ƂD    

    // A/DRo[^̐ݒ
    set_AD_Converter(select_AN7, AD_ON, left_justified, clock_1_32, neg_ref_VSS, pos_ref_VDD);   

        
    // D/ARo[^̐ݒ
    set_DA_Converter(DAC_on, DAC_not_to_DAC1OUT1, DAC_to_DAC1OUT2, DAC_Positive_Source_to_VDD, DAC_Negative_Source_to_VSS);

	for(;;)
    {
        //A/Dϊ
        start_ad_conversion();                          // A/DϊJn
        ad_out = read_result_of_ad_conversion();        // A/Dϊʂ ad_out Ɋi[
        intrpt_period = max_func(0xFFFF - ad_out, 172); // 荞ݎ̐ݒDintpr_period̉l172ɐݒ
      }
}